Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignmentArchive.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignmentArchive.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPAssignmentArchive.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,5 +23,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -36,117 +35,18 @@
       get { return solutions; }
       set {
-        bool changed = (solutions != value);
+        if (solutions == value) return;
         solutions = value;
-        if (changed) OnPropertyChanged("Solutions");
+        OnPropertyChanged(nameof(Solutions));
       }
     }
 
     [Storable]
-    private StringArray equipmentNames;
-    public StringArray EquipmentNames {
-      get { return equipmentNames; }
+    private GQAPInstance problemInstance;
+    public GQAPInstance ProblemInstance {
+      get { return problemInstance; }
       set {
-        bool changed = (equipmentNames != value);
-        equipmentNames = value;
-        if (changed) OnPropertyChanged("EquipmentNames");
-      }
-    }
-
-    [Storable]
-    private StringArray locationNames;
-    public StringArray LocationNames {
-      get { return locationNames; }
-      set {
-        bool changed = (locationNames != value);
-        locationNames = value;
-        if (changed) OnPropertyChanged("LocationNames");
-      }
-    }
-
-    [Storable]
-    private DoubleMatrix distances;
-    public DoubleMatrix Distances {
-      get { return distances; }
-      set {
-        bool changed = (distances != value);
-        distances = value;
-        if (changed) OnPropertyChanged("Distances");
-      }
-    }
-
-    [Storable]
-    private DoubleMatrix weights;
-    public DoubleMatrix Weights {
-      get { return weights; }
-      set {
-        bool changed = (weights != value);
-        weights = value;
-        if (changed) OnPropertyChanged("Weights");
-      }
-    }
-
-    [Storable]
-    private DoubleMatrix installationCosts;
-    public DoubleMatrix InstallationCosts {
-      get { return installationCosts; }
-      set {
-        bool changed = (installationCosts != value);
-        installationCosts = value;
-        if (changed) OnPropertyChanged("InstallationCosts");
-      }
-    }
-
-    [Storable]
-    private DoubleArray demands;
-    public DoubleArray Demands {
-      get { return demands; }
-      set {
-        bool changed = (demands != value);
-        demands = value;
-        if (changed) OnPropertyChanged("Demands");
-      }
-    }
-
-    [Storable]
-    private DoubleArray capacities;
-    public DoubleArray Capacities {
-      get { return capacities; }
-      set {
-        bool changed = (capacities != value);
-        capacities = value;
-        if (changed) OnPropertyChanged("Capacities");
-      }
-    }
-
-    [Storable]
-    private DoubleValue transportationCosts;
-    public DoubleValue TransportationCosts {
-      get { return transportationCosts; }
-      set {
-        bool changed = (transportationCosts != value);
-        transportationCosts = value;
-        if (changed) OnPropertyChanged("TransportationCosts");
-      }
-    }
-
-    [Storable]
-    private DoubleValue expectedRandomQuality;
-    public DoubleValue ExpectedRandomQuality {
-      get { return expectedRandomQuality; }
-      set {
-        bool changed = (expectedRandomQuality != value);
-        expectedRandomQuality = value;
-        if (changed) OnPropertyChanged("ExpectedRandomQuality");
-      }
-    }
-
-    [Storable]
-    private IGQAPEvaluator evaluator;
-    public IGQAPEvaluator Evaluator {
-      get { return evaluator; }
-      set {
-        bool changed = (evaluator != value);
-        evaluator = value;
-        if (changed) OnPropertyChanged("Evaluator");
+        if (problemInstance == value) return;
+        problemInstance = value;
+        OnPropertyChanged(nameof(ProblemInstance));
       }
     }
@@ -157,14 +57,5 @@
       : base(original, cloner) {
       solutions = cloner.Clone(original.solutions);
-      equipmentNames = cloner.Clone(original.equipmentNames);
-      locationNames = cloner.Clone(original.locationNames);
-      distances = cloner.Clone(original.distances);
-      weights = cloner.Clone(original.weights);
-      installationCosts = cloner.Clone(original.installationCosts);
-      demands = cloner.Clone(original.demands);
-      capacities = cloner.Clone(original.capacities);
-      transportationCosts = cloner.Clone(original.transportationCosts);
-      expectedRandomQuality = cloner.Clone(original.expectedRandomQuality);
-      evaluator = cloner.Clone(original.evaluator);
+      problemInstance = cloner.Clone(original.problemInstance);
     }
     public GQAPAssignmentArchive()
@@ -172,14 +63,7 @@
       this.solutions = new ItemList<GQAPSolution>();
     }
-    public GQAPAssignmentArchive(StringArray equipmentNames, StringArray locationNames, DoubleMatrix distances, DoubleMatrix weights, DoubleMatrix installationCosts, DoubleArray demands, DoubleArray capacities, DoubleValue transportationCosts, DoubleValue expectedRandomQuality, IGQAPEvaluator evaluator)
+    public GQAPAssignmentArchive(GQAPInstance problemInstance)
       : this() {
-      this.distances = distances;
-      this.weights = weights;
-      this.installationCosts = installationCosts;
-      this.demands = demands;
-      this.capacities = capacities;
-      this.transportationCosts = transportationCosts;
-      this.expectedRandomQuality = expectedRandomQuality;
-      this.evaluator = evaluator;
+      this.problemInstance = problemInstance;
     }
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPInstance.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPInstance.cs	(revision 15504)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPInstance.cs	(revision 15504)
@@ -0,0 +1,256 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  [Item("GQAP Instance", "Instance of a generalized quadratic assignment problem.")]
+  [StorableClass]
+  public class GQAPInstance : ParameterizedNamedItem {
+    public static readonly string WeightsDescription = "The weights matrix describes the flows between the equipments.";
+    public static readonly string DistancesDescription = "The distances matrix describes the distances between the locations at which the equipment can be installed.";
+    public static readonly string InstallationCostsDescription = "The installation costs matrix describes the installation costs of installing equipment i at location j";
+    public static readonly string DemandsDescription = "The demands vector describes the space requirements of the equipments.";
+    public static readonly string CapacitiesDescription = "The capacities vector describes the available space at the locations.";
+    public static readonly string TransportationCostsDescription = "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already.";
+    public static readonly string EquipmentNamesDescription = "Optional: A list of names that describes the equipments.";
+    public static readonly string LocationNamesDescription = "Optional: A list of names that describes the locations.";
+    public static readonly string PenaltyLevelDescription = "The quality that an infeasible solution cannot surpass.";
+
+
+    #region Parameter Properties
+    [Storable]
+    private ValueParameter<DoubleMatrix> weightsParam;
+    public IValueParameter<DoubleMatrix> WeightsParameter {
+      get { return weightsParam; }
+    }
+    [Storable]
+    private ValueParameter<DoubleMatrix> distancesParam;
+    public IValueParameter<DoubleMatrix> DistancesParameter {
+      get { return distancesParam; }
+    }
+    [Storable]
+    private ValueParameter<DoubleMatrix> installCostsParam;
+    public IValueParameter<DoubleMatrix> InstallationCostsParameter {
+      get { return installCostsParam; }
+    }
+    [Storable]
+    private ValueParameter<DoubleArray> demandsParam;
+    public IValueParameter<DoubleArray> DemandsParameter {
+      get { return demandsParam; }
+    }
+    [Storable]
+    private ValueParameter<DoubleArray> capacitiesParam;
+    public IValueParameter<DoubleArray> CapacitiesParameter {
+      get { return capacitiesParam; }
+    }
+    [Storable]
+    private FixedValueParameter<DoubleValue> transportationCostsParam;
+    public IFixedValueParameter<DoubleValue> TransportationCostsParameter {
+      get { return transportationCostsParam; }
+    }
+    [Storable]
+    private FixedValueParameter<DoubleValue> penaltyLevelParam;
+    public IFixedValueParameter<DoubleValue> PenaltyLevelParameter {
+      get { return penaltyLevelParam; }
+    }
+    [Storable]
+    private OptionalValueParameter<StringArray> equipmentNamesParam;
+    public OptionalValueParameter<StringArray> EquipmentNamesParameter {
+      get { return equipmentNamesParam; }
+    }
+    [Storable]
+    private OptionalValueParameter<StringArray> locationNamesParam;
+    public OptionalValueParameter<StringArray> LocationNamesParameter {
+      get { return locationNamesParam; }
+    }
+    #endregion
+
+    #region Properties
+    public DoubleMatrix Weights {
+      get { return WeightsParameter.Value; }
+      set { WeightsParameter.Value = value; }
+    }
+    public DoubleMatrix Distances {
+      get { return DistancesParameter.Value; }
+      set { DistancesParameter.Value = value; }
+    }
+    public DoubleMatrix InstallationCosts {
+      get { return InstallationCostsParameter.Value; }
+      set { InstallationCostsParameter.Value = value; }
+    }
+    public DoubleArray Demands {
+      get { return DemandsParameter.Value; }
+      set { DemandsParameter.Value = value; }
+    }
+    public DoubleArray Capacities {
+      get { return CapacitiesParameter.Value; }
+      set { CapacitiesParameter.Value = value; }
+    }
+    public double TransportationCosts {
+      get { return TransportationCostsParameter.Value.Value; }
+      set { TransportationCostsParameter.Value.Value = value; }
+    }
+    public double PenaltyLevel {
+      get { return PenaltyLevelParameter.Value.Value; }
+      set { PenaltyLevelParameter.Value.Value = value; }
+    }
+    public StringArray EquipmentNames {
+      get { return EquipmentNamesParameter.Value; }
+      set { EquipmentNamesParameter.Value = value; }
+    }
+    public StringArray LocationNames {
+      get { return LocationNamesParameter.Value; }
+      set { LocationNamesParameter.Value = value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected GQAPInstance(bool deserializing) : base(deserializing) { }
+    protected GQAPInstance(GQAPInstance original, Cloner cloner)
+      : base(original, cloner) {
+      weightsParam = cloner.Clone(original.weightsParam);
+      distancesParam = cloner.Clone(original.distancesParam);
+      installCostsParam = cloner.Clone(original.installCostsParam);
+      transportationCostsParam = cloner.Clone(original.transportationCostsParam);
+      penaltyLevelParam = cloner.Clone(original.penaltyLevelParam);
+      demandsParam = cloner.Clone(original.demandsParam);
+      capacitiesParam = cloner.Clone(original.capacitiesParam);
+      equipmentNamesParam = cloner.Clone(original.equipmentNamesParam);
+      locationNamesParam = cloner.Clone(original.locationNamesParam);
+    }
+    public GQAPInstance() {
+      Parameters.Add(weightsParam = new ValueParameter<DoubleMatrix>("Weights", WeightsDescription, new DoubleMatrix(), false));
+      Parameters.Add(distancesParam = new ValueParameter<DoubleMatrix>("Distances", DistancesDescription, new DoubleMatrix(), false));
+      Parameters.Add(installCostsParam = new ValueParameter<DoubleMatrix>("InstallationCosts", InstallationCostsDescription, new DoubleMatrix(), false));
+      Parameters.Add(transportationCostsParam = new FixedValueParameter<DoubleValue>("TransportationCosts", TransportationCostsDescription, new DoubleValue(1)));
+      Parameters.Add(penaltyLevelParam = new FixedValueParameter<DoubleValue>("PenaltyLevel", PenaltyLevelDescription, new DoubleValue(0), true));
+      Parameters.Add(demandsParam = new ValueParameter<DoubleArray>("Demands", DemandsDescription, new DoubleArray(), false));
+      Parameters.Add(capacitiesParam = new ValueParameter<DoubleArray>("Capacities", CapacitiesDescription, new DoubleArray(), false));
+      Parameters.Add(equipmentNamesParam = new OptionalValueParameter<StringArray>("EquipmentNames", EquipmentNamesDescription, null, false));
+      Parameters.Add(locationNamesParam = new OptionalValueParameter<StringArray>("LocationNames", LocationNamesDescription, null, false));
+
+      weightsParam.ReactOnValueToStringChangedAndValueItemImageChanged = false;
+      distancesParam.ReactOnValueToStringChangedAndValueItemImageChanged = false;
+      installCostsParam.ReactOnValueToStringChangedAndValueItemImageChanged = false;
+      demandsParam.ReactOnValueToStringChangedAndValueItemImageChanged = false;
+      capacitiesParam.ReactOnValueToStringChangedAndValueItemImageChanged = false;
+
+      Weights = new DoubleMatrix(5, 5);
+      Weights[0, 0] = Weights[1, 1] = Weights[2, 2] = Weights[3, 3] = Weights[4, 4] = 0;
+      Weights[0, 1] = Weights[1, 0] = Weights[0, 2] = Weights[2, 0] = Weights[0, 3] = Weights[3, 0] = Weights[0, 4] = Weights[4, 0] = 10;
+      Weights[1, 2] = Weights[2, 1] = Weights[1, 3] = Weights[3, 1] = Weights[1, 4] = Weights[4, 1] = 5;
+      Weights[2, 3] = Weights[3, 2] = Weights[2, 4] = Weights[4, 2] = 7.5;
+      Weights[3, 4] = Weights[4, 3] = 2.5;
+
+      Distances = new DoubleMatrix(3, 3);
+      Distances[0, 0] = Distances[1, 1] = Distances[2, 2] = 0;
+      Distances[0, 1] = Distances[1, 0] = Distances[1, 2] = Distances[2, 1] = 1;
+      Distances[0, 2] = Distances[2, 0] = 2;
+
+      InstallationCosts = new DoubleMatrix(5, 3);
+
+      Demands = new DoubleArray(5);
+      Demands[0] = 2; Demands[1] = 1; Demands[2] = 3; Demands[3] = 1; Demands[4] = 1;
+
+      Capacities = new DoubleArray(3);
+      Capacities[0] = 4; Capacities[1] = 1; Capacities[2] = 4;
+
+      TransportationCosts = 1;
+
+      CalculatePenaltyLevel();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GQAPInstance(this, cloner);
+    }
+
+    public Evaluation Evaluate(IntegerVector assignment) {
+      return EvaluateIntegerVector(assignment, Demands, Capacities,
+        InstallationCosts, Weights, Distances);
+    }
+
+    public static Evaluation EvaluateIntegerVector(IntegerVector assignment,
+      DoubleArray demands, DoubleArray capacities, DoubleMatrix installCosts,
+      DoubleMatrix weights, DoubleMatrix distances) {
+      var flowDistanceQuality = 0.0;
+      var installationQuality = 0.0;
+      var overbookedCapacity = 0.0;
+      int len = assignment.Length;
+      var slack = capacities.ToArray();
+
+      for (int i = 0; i < len; i++) {
+        var assignI = assignment[i];
+        installationQuality += installCosts[i, assignI];
+        for (int j = 0; j < len; j++) {
+          flowDistanceQuality += weights[i, j] * distances[assignI, assignment[j]];
+        }
+        if (slack[assignI] < 0) overbookedCapacity += demands[i];
+        else if (slack[assignI] < demands[i]) overbookedCapacity += (demands[i] - slack[assignI]);
+        slack[assignI] -= demands[i];
+      }
+      return new Evaluation() {
+        ExcessDemand = overbookedCapacity,
+        FlowCosts = flowDistanceQuality,
+        InstallationCosts = installationQuality,
+        Slack = slack
+      };
+    }
+
+    public double ToSingleObjective(Evaluation fitness) {
+      return fitness.IsFeasible
+        ? fitness.InstallationCosts + TransportationCosts * fitness.FlowCosts
+        : PenaltyLevel + fitness.ExcessDemand;
+    }
+
+    public double[] ToMultiObjectiveStrict(Evaluation fitness) {
+      return fitness.IsFeasible
+        ? new double[] { fitness.InstallationCosts, TransportationCosts * fitness.FlowCosts }
+        : new double[] { PenaltyLevel + fitness.ExcessDemand, PenaltyLevel + fitness.ExcessDemand };
+    }
+
+    public double[] ToMultiObjectiveRelaxed(Evaluation fitness) {
+      return new double[] {
+        fitness.InstallationCosts,
+        TransportationCosts * fitness.FlowCosts,
+        fitness.ExcessDemand };
+    }
+
+    public bool IsValid() {
+      return Weights != null && Distances != null && Demands != null && Capacities != null && InstallationCosts != null
+        && Weights.Rows == Weights.Columns && Weights.Rows == InstallationCosts.Rows
+        && Distances.Rows == Distances.Columns && Distances.Rows == InstallationCosts.Columns
+        && Demands.Length == Weights.Rows && Capacities.Length == Distances.Rows;
+    }
+
+    public void CalculatePenaltyLevel() {
+      var flowQuality = Distances.Max() * Weights.Max() * Demands.Length * Demands.Length;
+      var installQuality = InstallationCosts.Max() * Demands.Length;
+      PenaltyLevel = installQuality + TransportationCosts * flowQuality;
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPSolution.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPSolution.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GQAPSolution.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,5 +23,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -44,44 +43,11 @@
 
     [Storable]
-    private DoubleValue quality;
-    public DoubleValue Quality {
-      get { return quality; }
+    private Evaluation evaluation;
+    public Evaluation Evaluation {
+      get { return evaluation; }
       set {
-        bool changed = (quality != value);
-        quality = value;
-        if (changed) OnPropertyChanged("Quality");
-      }
-    }
-
-    [Storable]
-    private DoubleValue flowDistanceQuality;
-    public DoubleValue FlowDistanceQuality {
-      get { return flowDistanceQuality; }
-      set {
-        bool changed = (flowDistanceQuality != value);
-        flowDistanceQuality = value;
-        if (changed) OnPropertyChanged("FlowDistanceQuality");
-      }
-    }
-
-    [Storable]
-    private DoubleValue installationQuality;
-    public DoubleValue InstallationQuality {
-      get { return installationQuality; }
-      set {
-        bool changed = (installationQuality != value);
-        installationQuality = value;
-        if (changed) OnPropertyChanged("InstallationQuality");
-      }
-    }
-
-    [Storable]
-    private DoubleValue overbookedCapacity;
-    public DoubleValue OverbookedCapacity {
-      get { return overbookedCapacity; }
-      set {
-        bool changed = (overbookedCapacity != value);
-        overbookedCapacity = value;
-        if (changed) OnPropertyChanged("OverbookedCapacity");
+        if (evaluation == value) return;
+        evaluation = value;
+        OnPropertyChanged(nameof(Evaluation));
       }
     }
@@ -92,16 +58,10 @@
       : base(original, cloner) {
       assignment = cloner.Clone(original.assignment);
-      quality = cloner.Clone(original.quality);
-      flowDistanceQuality = cloner.Clone(original.flowDistanceQuality);
-      installationQuality = cloner.Clone(original.installationQuality);
-      overbookedCapacity = cloner.Clone(original.overbookedCapacity);
+      evaluation = cloner.Clone(original.evaluation);
     }
-    public GQAPSolution(IntegerVector assignment, DoubleValue quality, DoubleValue flowDistanceQuality, DoubleValue installationQuality, DoubleValue overbookedCapacity)
+    public GQAPSolution(IntegerVector assignment, Evaluation evaluation)
       : base() {
       this.assignment = assignment;
-      this.quality = quality;
-      this.flowDistanceQuality = flowDistanceQuality;
-      this.installationQuality = installationQuality;
-      this.overbookedCapacity = overbookedCapacity;
+      this.evaluation = evaluation;
     }
 
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj	(revision 15504)
@@ -98,13 +98,8 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Analyzers\BestGQAPSolutionAnalyzer.cs" />
-    <Compile Include="Analyzers\GQAPSolutionArchiveUpdater.cs" />
-    <Compile Include="Analyzers\GQAPPopulationDiversityAnalyzer.cs" />
-    <Compile Include="Analyzers\GQAPSolutionArchiveAnalyzer.cs" />
-    <Compile Include="Evaluators\GQAPPenaltyLevelEvaluator.cs" />
-    <Compile Include="Evaluators\GQAPEvaluator.cs" />
-    <Compile Include="Evaluators\GQAPNMoveEvaluator.cs" />
+    <Compile Include="Evaluation\Evaluation.cs" />
+    <Compile Include="Evaluation\GQAPNMoveEvaluator.cs" />
     <Compile Include="GQAPAssignment.cs" />
-    <Compile Include="Interfaces\IEvaluatorAwareGQAPOperator.cs" />
+    <Compile Include="GQAPInstance.cs" />
     <Compile Include="Operators\Crossovers\CordeauCrossover.cs" />
     <Compile Include="SolutionCreators\SlackMinimizationSolutionCreator.cs" />
@@ -113,37 +108,24 @@
     <Compile Include="SolutionCreators\GQAPStochasticSolutionCreator.cs" />
     <Compile Include="SolutionCreators\GreedyRandomizedSolutionCreator.cs" />
-    <Compile Include="SolutionCreators\RandomSolutionCreator.cs" />
     <None Include="Plugin.cs.frame" />
-    <Compile Include="Evaluators\GQAPAdditivePenaltyEvaluator.cs" />
-    <Compile Include="GeneralizedQuadraticAssignmentProblem.cs" />
+    <Compile Include="GQAP.cs" />
     <Compile Include="GQAPAssignmentArchive.cs" />
     <Compile Include="GQAPSolution.cs" />
-    <Compile Include="Interfaces\IBestKnownSolutionsAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IGQAPManipulator.cs" />
-    <Compile Include="Interfaces\IQualitiesAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IAssignmentsAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IBestKnownQualityAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IBestKnownSolutionAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\ILocationNamesAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IEquipmentNamesAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IMoveQualityAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IGQAPEvaluator.cs" />
-    <Compile Include="Interfaces\IQualityAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IExpectedRandomQualityAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\ITransportationCostsAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IInstallationCostsAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IDistancesAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IWeightsAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IAssignmentAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IGQAPNMoveEvaluator.cs" />
-    <Compile Include="Interfaces\IDemandsAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IGQAPCrossover.cs" />
-    <Compile Include="Interfaces\IGQAPLocalImprovementOperator.cs" />
-    <Compile Include="Interfaces\IGQAPMoveEvaluator.cs" />
-    <Compile Include="Interfaces\IGQAPMoveOperator.cs" />
-    <Compile Include="Interfaces\IGQAPNMoveOperator.cs" />
-    <Compile Include="Interfaces\IGQAPOperator.cs" />
-    <Compile Include="Interfaces\IGQAPSolutionCreator.cs" />
-    <Compile Include="Interfaces\ICapacitiesAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\Parameter\IBestKnownSolutionsAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPManipulator.cs" />
+    <Compile Include="Interfaces\Parameter\IQualitiesAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\Parameter\IBestKnownQualityAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\Parameter\IBestKnownSolutionAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\Parameter\IMoveQualityAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\Parameter\IQualityAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\Parameter\IProblemInstanceAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPNMoveEvaluator.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPCrossover.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPLocalImprovementOperator.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPMoveEvaluator.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPMoveOperator.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPNMoveOperator.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPOperator.cs" />
+    <Compile Include="Interfaces\Operator\IGQAPSolutionCreator.cs" />
     <Compile Include="Moves\NMove.cs" />
     <Compile Include="Moves\GQAPMoveGenerator.cs" />
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/Operator/IGQAPCrossover.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/Operator/IGQAPCrossover.cs	(revision 15504)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/Operator/IGQAPCrossover.cs	(revision 15504)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IGQAPCrossover : IGQAPOperator, ICrossover {
+    IScopeTreeLookupParameter<IntegerVector> ParentsParameter { get; }
+    ILookupParameter<IntegerVector> ChildParameter { get; }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/Operator/IGQAPLocalImprovementOperator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/Operator/IGQAPLocalImprovementOperator.cs	(revision 15504)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/Operator/IGQAPLocalImprovementOperator.cs	(revision 15504)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IGQAPLocalImprovementOperator : ILocalImprovementAlgorithmOperator {
+    IValueLookupParameter<IntValue> MaximumCandidateListSizeParameter { get; }
+    ILookupParameter<IntegerVector> AssignmentParameter { get; }
+  }
+}
